'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactUtils = require('react-utils');

var _reactUtils2 = _interopRequireDefault(_reactUtils);

var _velocityReact = require('velocity-react');

var _decorators = require('./decorators');

var _decorators2 = _interopRequireDefault(_decorators);

var _themesDefault = require('../themes/default');

var _themesDefault2 = _interopRequireDefault(_themesDefault);

var _themesAnimations = require('../themes/animations');

var _themesAnimations2 = _interopRequireDefault(_themesAnimations);

var NodeHeader = (function (_React$Component) {
    _inherits(NodeHeader, _React$Component);

    function NodeHeader(props) {
        _classCallCheck(this, _NodeHeader);

        _get(Object.getPrototypeOf(_NodeHeader.prototype), 'constructor', this).call(this, props);
    }

    _createClass(NodeHeader, [{
        key: 'render',
        value: function render() {
            var _props = this.props;
            var style = _props.style;
            var animations = _props.animations;
            var decorators = _props.decorators;

            var terminal = this.props.node.terminal;
            var active = this.props.node.active;
            var linkStyle = [style.link, active ? style.activeLink : null];
            return _react2['default'].createElement(
                'a',
                { href: '#', onClick: this.props.onClick, style: linkStyle },
                !terminal ? this.renderToggle(decorators, animations) : '',
                _react2['default'].createElement(decorators.Header, {
                    name: this.props.node.name,
                    style: style.header
                })
            );
        }
    }, {
        key: 'renderToggle',
        value: function renderToggle(decorators, animations) {
            var Toggle = decorators.Toggle;
            var style = this.props.style;
            return _react2['default'].createElement(
                _velocityReact.VelocityComponent,
                {
                    duration: animations.toggle.duration,
                    animation: animations.toggle.animation },
                _react2['default'].createElement(Toggle, { style: style.toggle })
            );
        }
    }]);

    var _NodeHeader = NodeHeader;
    NodeHeader = (0, _radium2['default'])(NodeHeader) || NodeHeader;
    return NodeHeader;
})(_react2['default'].Component);

NodeHeader.propTypes = {
    style: _react2['default'].PropTypes.object.isRequired,
    decorators: _react2['default'].PropTypes.object.isRequired,
    animations: _react2['default'].PropTypes.object.isRequired,
    onClick: _react2['default'].PropTypes.func.isRequired,
    node: _react2['default'].PropTypes.object.isRequired
};

var TreeNode = (function (_React$Component2) {
    _inherits(TreeNode, _React$Component2);

    function TreeNode(props) {
        _classCallCheck(this, TreeNode);

        _get(Object.getPrototypeOf(TreeNode.prototype), 'constructor', this).call(this, props);
        this.state = { toggled: props.node.toggled };
        this.onClick = this.onClick.bind(this);
    }

    _createClass(TreeNode, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {
            var toggled = props.node.toggled;
            if (toggled !== undefined) {
                this.setState({ toggled: toggled });
            }
        }
    }, {
        key: 'onClick',
        value: function onClick() {
            var toggled = !this.state.toggled;
            var onToggle = this.props.onToggle;
            if (onToggle) {
                onToggle(this.props.node, toggled);
            }
            this.setState({ toggled: toggled });
        }
    }, {
        key: 'animations',
        value: function animations() {
            var props = this.props;
            var anim = _Object$assign({}, props.animations, props.node.animations);
            return {
                toggle: anim.toggle(this.state),
                drawer: anim.drawer(this.state)
            };
        }
    }, {
        key: 'decorators',
        value: function decorators() {
            // Merge Any Node Based Decorators Into The Pack
            var props = this.props;
            var nodeDecorators = props.node.decorators || {};
            return _Object$assign({}, props.decorators, nodeDecorators);
        }
    }, {
        key: 'render',
        value: function render() {
            var decorators = this.decorators();
            var animations = this.animations();
            var toggled = this.state.toggled;
            return _react2['default'].createElement(
                'li',
                { style: this.props.style.base },
                this.renderHeader(decorators, animations),
                _react2['default'].createElement(
                    _velocityReact.VelocityTransitionGroup,
                    animations.drawer,
                    toggled ? this.renderChildren(decorators, animations) : null
                )
            );
        }
    }, {
        key: 'renderHeader',
        value: function renderHeader(decorators, animations) {
            return _react2['default'].createElement(NodeHeader, {
                decorators: decorators,
                animations: animations,
                style: this.props.style,
                node: this.props.node,
                onClick: this.onClick
            });
        }
    }, {
        key: 'renderChildren',
        value: function renderChildren(decorators) {
            var _this = this;

            return _react2['default'].createElement(
                'ul',
                { style: this.props.style.subtree },
                this.renderLoading(decorators),
                _reactUtils2['default'].children.map(this.props.node.children, function (child, index) {
                    return _react2['default'].createElement(TreeNode, _extends({}, _this._eventBubbles(), {
                        key: index,
                        node: child,
                        decorators: _this.props.decorators,
                        animations: _this.props.animations,
                        style: _this.props.style
                    }));
                })
            );
        }
    }, {
        key: 'renderLoading',
        value: function renderLoading() {
            var Loading = this.props.decorators.Loading;
            if (this.props.node.loading && Loading) {
                return _react2['default'].createElement(
                    'li',
                    null,
                    _react2['default'].createElement(Loading, { style: this.props.style.loading })
                );
            }
        }
    }, {
        key: '_eventBubbles',
        value: function _eventBubbles() {
            return { onToggle: this.props.onToggle };
        }
    }]);

    return TreeNode;
})(_react2['default'].Component);

TreeNode.propTypes = {
    style: _react2['default'].PropTypes.object.isRequired,
    node: _react2['default'].PropTypes.object.isRequired,
    decorators: _react2['default'].PropTypes.object.isRequired,
    animations: _react2['default'].PropTypes.object.isRequired,
    onToggle: _react2['default'].PropTypes.func
};

TreeNode.defaultProps = {};

var TreeBeard = (function (_React$Component3) {
    _inherits(TreeBeard, _React$Component3);

    function TreeBeard(props) {
        _classCallCheck(this, TreeBeard);

        _get(Object.getPrototypeOf(TreeBeard.prototype), 'constructor', this).call(this, props);
    }

    _createClass(TreeBeard, [{
        key: 'render',
        value: function render() {
            return _react2['default'].createElement(
                'div',
                null,
                _react2['default'].createElement(
                    'ul',
                    { style: this.props.style.tree.base },
                    _react2['default'].createElement(TreeNode, {
                        node: this.props.data,
                        onToggle: this.props.onToggle,
                        animations: this.props.animations,
                        decorators: this.props.decorators,
                        style: this.props.style.tree.node
                    })
                )
            );
        }
    }]);

    return TreeBeard;
})(_react2['default'].Component);

TreeBeard.propTypes = {
    style: _react2['default'].PropTypes.object,
    data: _react2['default'].PropTypes.object.isRequired,
    animations: _react2['default'].PropTypes.object,
    onToggle: _react2['default'].PropTypes.func,
    decorators: _react2['default'].PropTypes.object
};

TreeBeard.defaultProps = {
    style: _themesDefault2['default'],
    animations: _themesAnimations2['default'],
    decorators: _decorators2['default']
};

exports['default'] = TreeBeard;
module.exports = exports['default'];